'     QUOTECHK.BAS  - Quote checker routine -
'     This routine totals the number of quotation marks per line and prints
'     the line if the counts are odd:  If the counts are odd but the line
'     ends with a + (the Rbase continuation symbol) then the routine skips
'     to the next line before comparing totals. The routine also skips full
'     comment lines,ie-lines beginning with -- or beginning with a *( and
'     ending with ).  It also skips any line starting with SET QUO, ie-the
'     SET QUOTES command.
'                                             created 19 July 91; Wm Driskell

CLS
PRINT "Quotation Marks Checker"
PRINT "-----------------------"
PRINT

INPUT "Enter name of file to check: ", ifile$
INPUT "Enter name of file for output: ", ofile$
OPEN "I", #1, ifile$
OPEN "O", #2, ofile$
PRINT #2, "file: "; ifile$
PRINT #2,
PRINT #2, "Line #: total quote count, "; CHR$(34); " and '"
PRINT
PRINT "Line #: total quote count,"; CHR$(34); " and '"

' setup counters and constants
 fqknt = 0      'counters
 sqknt = 0
 fq$ = CHR$(34) 'search strings
 sq$ = CHR$(39)
 fx = 1         'position within text line
 sx = 1

 ' get line and parse for parentheses
 DO UNTIL EOF(1)
  LINE INPUT #1, a$
  lineknt = lineknt + 1
  IF RIGHT$(a$, 1) <> "+" THEN
   IF LEFT$(a$, 2) = "--" OR (LEFT$(a$, 2) = "*(" AND RIGHT$(a$, 1) = ")") THEN
    GOTO 10   'skip a comment line
   END IF
  END IF
  IF INSTR(1, a$, "set quo") > 0 THEN
   GOTO 10    'skip a SET QUOTE statement
  END IF
  DO
   l = INSTR(fx, a$, fq$)
   r = INSTR(sx, a$, sq$)
   IF l > 0 THEN
    fqknt = fqknt + 1
    fx = l + 1
   END IF
   IF r > 0 THEN
    sqknt = sqknt + 1
    sx = r + 1
   END IF
  LOOP UNTIL l = 0 AND r = 0
'  write when count is odd for either quote and line is not continued
10 IF (fqknt MOD 2 = 1 OR sqknt MOD 2 = 1) AND RIGHT$(a$, 1) <> "+" THEN
    PRINT "==>"; lineknt; ": "; fqknt; sqknt    
    PRINT a$
    PRINT #2, "==>"; lineknt; ": "; fqknt; sqknt
    PRINT #2, a$
   END IF
  fx = 1
  sx = 1
 LOOP
 PRINT
 PRINT "::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
 PRINT
 PRINT "total lines processed: "; lineknt
 PRINT "total number of quotes processed: "
 PRINT TAB(20); CHR$(34); " - "; fqknt
 PRINT TAB(20); "' - "; sqknt
 PRINT "       (ignoring full comment lines and SET QUOTE commands)"
 PRINT "::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
 PRINT
 PRINT #2,
 PRINT #2, ":::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
 PRINT #2,
 PRINT #2, "total lines processed: "; lineknt
 PRINT #2, "total number of quotes processed: "
 PRINT #2, CHR$(34); " - "; fqknt
 PRINT #2, " ' - "; rpknt
 PRINT #2, "        (ignoring full comment lines and SET QUOTE commands)"
 PRINT #2, ":::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::"
 PRINT #2,
 CLOSE #2
END








